/**
 *
 * @(#)BombApp.java 1.5 1998/06/21
 * BombAvP[V
 *  JDK1.1.X + swing1.02
 * @version 1.5
 * @author Qini.Nakagawa
 */

package jp.gr.java_conf.narick.game.mine;
import jp.gr.java_conf.narick.game.mine.*;
import javax.swing.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;

/** JavaŔeTQ[ AvP[V ʃ[` */
public abstract class BombApp extends JFrame
    implements ActionListener {
    BombCanvas mCanvas;
    BombPanel mainPanel;
    ButtonGroup bg;

    /** VKR}hNX */
    class NewCmd implements ActionListener {
	BombCanvas vc;
	public NewCmd(BombCanvas c){
	    vc = c;
	}
	public void actionPerformed(ActionEvent e){
	    vc.reset();
	}
    }
    /** C[W̃[h */
    private Image loadImage(){
        int i;
        Image im = null;

        try{
            Toolkit t = Toolkit.getDefaultToolkit();
            MediaTracker tracker = new MediaTracker( this );
            URL url = getClass().getResource("/jp/gr/java_conf/narick/game/mine/image/MineImage.gif");
            im = t.createImage((ImageProducer)url.getContent());
            tracker.addImage(im, 1);
            tracker.waitForID(1);
        }
        catch( InterruptedException e ){
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
        return im;
    }
    /** CjVCY */
    public void loInit(BombCanvas canvas){
        BombBase.res = ResourceBundle.getBundle("jp.gr.java_conf.narick.game.mine.BombRes");
        setTitle(BombBase.res.getString("TITLE"));
        Image im = loadImage();
        addNotify();
/*
  // Look and Feel 鎞͂Ȋ
        String laf = UIManager.getSystemLookAndFeelClassName();
        try {
            UIManager.setLookAndFeel(laf);
        } catch (UnsupportedLookAndFeelException exc) {
            System.err.println("Warning: UnsupportedLookAndFeel: " + laf);
        } catch (Exception exc) {
            System.err.println("Error loading " + laf + ": " + exc);
        }
*/
	BombSys.pane = getContentPane();
        mCanvas = canvas;
        mainPanel = new BombPanel(mCanvas);
        getContentPane().add(mainPanel);
        mCanvas.setTileImage(im);
        BombBase.scoreset = new ScoreSet();
        SwingUtilities.updateComponentTreeUI(this);
        BombBase.scoreset.loadFile();
    }
    public void actionPerformed(ActionEvent e){
        String mname;
        Object o = e.getSource();
        if (o instanceof Button){
            if ( "Reset".equals( ((Button)o).getLabel())){
                mCanvas.reset();
                return;
            }
        }else if (o instanceof JCheckBoxMenuItem){
        mname = ((JCheckBoxMenuItem)o).getName();
        if (mname.equals("CRATERS")){
                mCanvas.fGameType[mCanvas.CRATERS] = ((JCheckBoxMenuItem)o).getState();
                mCanvas.reset();
                return;
            }else if (mname.equals("RANDOMIZER")){
                mCanvas.fGameType[mCanvas.RANDOMIZER] = ((JCheckBoxMenuItem)o).getState();
                mCanvas.reset();
                return;
            }else if (mname.equals("PAUSE")){
                mCanvas.pauseTrug();
                return;
            }
        }else if (o instanceof JMenuItem){
            if ("NEW".equals(((JMenuItem)o).getName())){
                mCanvas.reset();
                return;
            }else if ("SHOW".equals(((JMenuItem)o).getName())){
                showScores();
            }else if ("EXPORT".equals(((JMenuItem)o).getName())){
		JFileChooser fch = new JFileChooser();
		if(fch.showSaveDialog(this) != JFileChooser.CANCEL_OPTION){
		    BombBase.scoreset.saveFile(
			fch.getSelectedFile().getAbsolutePath());
		}
            }else if ("IMPORT".equals(((JMenuItem)o).getName())){
		JFileChooser fch = new JFileChooser();
		if(fch.showOpenDialog(this) != JFileChooser.CANCEL_OPTION){
		    BombBase.scoreset.loadFile(
			fch.getSelectedFile().getAbsolutePath());
		}
            }else if (((JMenuItem)o).getName().equals("CLEAR")){
                BombBase.scoreset.reset();
            }else if (((JMenuItem)o).getName().equals("EASY")){
                mCanvas.setMode(0);
                pack();
                return;
            }else if (((JMenuItem)o).getName().equals("INTERMEDIATE")){
                mCanvas.setMode(1);
                pack();
                return;
            }else if (((JMenuItem)o).getName().equals("DIFFICULT")){
                mCanvas.setMode(2);
                pack();
                return;
            }
        }
    }
    public BombApp(){
        super("JBomb");
	BombBase.mainContainer = this;
    }
    public void appStart(){
        //    EBhE֌W
        JMenuBar mbar = new JMenuBar();
        JMenu menu = new JMenu(BombBase.res.getString("GAME"));
        JMenuItem mitem = new JMenuItem(BombBase.res.getString("NEW"));
        mitem.setName("NEW");
        mitem.addActionListener(new NewCmd(mCanvas));
        menu.add(mitem);
        mitem = new JCheckBoxMenuItem(BombBase.res.getString("PAUSE"));
        mitem.setName("PAUSE");
        mitem.addActionListener(this);
        menu.add(mitem);
        mitem = new JMenuItem(BombBase.res.getString("QUIT"));
        menu.add(mitem);
        mitem.addActionListener(new ActionListener(){
	    public void actionPerformed(ActionEvent e){
		System.exit(0);
	    }
	});
        mbar.add(menu);
        menu = new JMenu(BombBase.res.getString("SCORE"));
        mitem = new JMenuItem(BombBase.res.getString("EXPORT"));
        mitem.setName("EXPORT");
        mitem.addActionListener(this);
        menu.add(mitem);
        mitem = new JMenuItem(BombBase.res.getString("IMPORT"));
        mitem.setName("IMPORT");
        mitem.addActionListener(this);
        menu.add(mitem);
        menu.addSeparator();
        mitem = new JMenuItem(BombBase.res.getString("SHOW"));
        mitem.setName("SHOW");
        mitem.addActionListener(this);
        menu.add(mitem);
        mitem = new JMenuItem(BombBase.res.getString("CLEAR"));
        mitem.setName("CLEAR");
        mitem.addActionListener(this);
        menu.add(mitem);
        mbar.add(menu);
        menu = new JMenu(BombBase.res.getString("OPTION"));
        bg = new ButtonGroup();
        JRadioButtonMenuItem rmitem = new JRadioButtonMenuItem(
	    BombBase.res.getString("EASY"));
        rmitem.setName("EASY");
        rmitem.addActionListener(this);
        bg.add(rmitem);
        menu.add(rmitem);
        rmitem = new JRadioButtonMenuItem(
	    BombBase.res.getString("INTERMEDIATE"));
        rmitem.setName("INTERMEDIATE");
        rmitem.addActionListener(this);
        bg.add(rmitem);
        menu.add(rmitem);
        rmitem = new JRadioButtonMenuItem(BombBase.res.getString("DIFFICULT"), true);
        rmitem.setName("DIFFICULT");
        rmitem.addActionListener(this);
        bg.add(rmitem);
        menu.add(rmitem);
	rmitem.setSelected(true);
        menu.addSeparator();
        mitem = new JCheckBoxMenuItem(BombBase.res.getString("CRATERS"));
        mitem.setName("CRATERS");
        mitem.addActionListener(this);
        menu.add(mitem);
        mitem = new JCheckBoxMenuItem(BombBase.res.getString("RANDOMIZER"));
        mitem.setName("RANDOMIZER");
        mitem.addActionListener(this);
        menu.add(mitem);
        mbar.add(menu);
        setJMenuBar(mbar);
	mCanvas.setMode(2);
        addWindowListener(new WindowAdapter(){
	    public void windowClosing(WindowEvent e){
		System.exit(0);
	    }
	});
    }
    /** nCXRA̕\ */
    protected void showScores(){
        BombBase.scoreset.showDialog();
    }
    public void pack(){
        super.pack();
        Insets i = getInsets();
        Dimension d = mainPanel.getPreferredSize();
        int h = getJMenuBar().getHeight();
        setSize(d.width + i.left + i.right, d.height + i.top + i.bottom + h);
    }
    protected void finalize() throws Throwable{
        BombBase.scoreset.saveFile();
    }
}
