/**
 * eTQ[
 *  JDK1.1.X + swing1.02
 * @version 1.5
 * @author Qini.Nakagawa
 */

package jp.gr.java_conf.narick.game.mine;
import jp.gr.java_conf.narick.game.mine.*;
import jp.gr.java_conf.narick.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/** pl\̋ʃ[` */
public abstract class BombCanvas extends JComponent
    implements MouseListener, MouseMotionListener, ItemListener{
    //    pattern enum.
    static final int UNDEF = -1;
    static final int OPEN_0 = 0;
    static final int OPEN_1 = 1;
    static final int OPEN_2 = 2;
    static final int OPEN_3 = 3;
    static final int OPEN_4 = 4;
    static final int OPEN_5 = 5;
    static final int OPEN_6 = 6;
    static final int OPEN_7 = 7;
    static final int OPEN_8 = 8;
    static final int CLOSE = 9;
    static final int FLAG = 10;
    static final int QUESTION = 11;
    static final int PUSH = 12;
    static final int QPUSH = 13;
    static final int BOMB = 14;
    static final int WRONG = 15;
    static final int MISSBOMB = 16;
    static final int PAT_CRATER = 26;
    static final int PAT_RANDOM = 27;
//    status enum.
    static final int STAT_IDLE = 0;
    static final int STAT_PLAY = 1;
    static final int STAT_WIN = 2;
    static final int STAT_LOSE = 3;
    boolean pause = false;
    int status = 0;
    int mode = 2;    //    Փx

//    \GA
    /** E̎ԕ\ */
    public StopWatch lcdTime = new StopWatch();
    /** LCD\ */
    public JLcd lcdRest = new JLcd();
//    push enum.
    static final int CLICK_OPEN = 1;
    static final int CLICK_MARK = 3;
    int fPush;
    /** pl̃TCY */
    static final int tileSize = 16;
//    labels
//    maximum
    int maxRows, maxCols, maxMines;
    int maxPanels;
    int nOpen, nRest;
    Point oldPos = null;
    protected int reservex;
    protected  int reservey;
    boolean fGameType[] = new boolean[3];
    static final int CRATERS = 0;
    static final int RANDOMIZER = 1;
    static final int MOVING = 2;
    Point randomPos;
    boolean bomb[][];
    Image image;
    Image panelImage[];
    protected int request[][];
    protected int current[][];
// around
    protected int aDx[], aDy[];
//    constructor
    public BombCanvas(){
        addMouseMotionListener(this);
        addMouseListener(this);
    }
    protected void fitting(){
	if (BombBase.mainContainer == null) return;
        if (BombBase.mainContainer instanceof Frame){
            ((Frame)BombBase.mainContainer).pack();
        } else {
	    System.out.println("fitting for Applet");
            invalidate();
            BombBase.mainContainer.validate();
        }
    }
    public void setTileImage(Image im){
        panelImage = new Image[ 28 ];
        for (int i = 0 ; i < 28 ; ++i){
            panelImage[ i ] = createImage(tileSize, tileSize);
            if (panelImage[ i ] == null){
                System.err.println("error!");
                return;
            }
            Graphics g = panelImage[ i ].getGraphics();
            g.clipRect(0, 0, tileSize, tileSize);
            g.drawImage(im, -(i % 16) * tileSize, -(i / 16) * tileSize, null);
        }
    }
    protected abstract void setting(int height, int width, int bombs);
    public boolean superClick(int row, int col){
        if (getPanel(row, col) > 8 || getPanel(row, col) <= 0) return false;
        int count = 0;
        for (int i = 0; i < aDx.length; ++i){
	    if (row + aDy[i] < 0 || col + aDx[i] < 0) continue;
	    if (getPanel(row + aDy[i], col + aDx[i]) == FLAG) ++count;
	}
        if (getPanel(row, col) != count){
	    return false;
	}
        if (!openAround(row, col)){
            lose();
        }
        if (nOpen + maxMines == maxPanels){
            win();
        }
        return true;
    }
    public abstract void reset();
    public abstract void setMode(int n);
    public void pauseTrug(){
        if (pause){
            pause = false;
	    if (status != STAT_PLAY) return;
            lcdTime.startTimer();
        }else{
            lcdTime.stopTimer();
            pause = true;
        }
        repaint();
    }
    protected void shuffleMines(){
        int i, j, x, y;
        for (i = 1 ; i < maxRows + 1 ; ++i){
            for(j = 1 ; j < maxCols + 1 ; ++j){
                bomb[ i ][ j ] = false;
            }
        }
        //    set mines
        i = 0;
        int [] array = RandomArray.getRandomArray(maxPanels - nOpen);
        for (y = 0; y < maxRows; ++y){
            for(x = 0; x < maxCols; ++x){
                if (getPanel(y, x) == PAT_CRATER ||
		    getPanel(y, x) == UNDEF ||
		    isOpen(y, x)) continue;
                if (array[i]< maxMines){
                    bomb[ y + 1 ][ x + 1 ] = true;
                } else if (array[i] == maxMines){
                    reservex = x;
                    reservey = y;
                }
                ++i;
            }
        }
    }
    // pl̐̍ČvZ
    protected void recalc(){
        int i,j;
        for (i = 0 ; i < maxRows ; ++i){
            for(j = 0 ; j < maxCols ; ++j){
                if(isOpen(i, j)){
                    setPanel(i,j,getOpenPat(i, j));
                }
            }
        }
    }
    boolean isBomb(int row, int col){
        return bomb[row + 1][col + 1];
    }
    final boolean isOpen(int row, int col){
        int p = getPanel(row, col);
        if ((p >= OPEN_0 && p <= OPEN_8) || p == PAT_RANDOM) return true;
        return false;
    }
    boolean isClose(int row, int col){
        int p = getPanel(row, col);
        return (p == CLOSE || p == FLAG || p == QUESTION);
    }
    //    open a panel
    protected boolean oneOpen(int row, int col){
        if (status == STAT_IDLE){
            status = STAT_PLAY;
            lcdTime.startTimer();
            if (isBomb(row, col)){
                bomb[row + 1][col + 1] = false;
                bomb[reservey + 1][reservex + 1] = true;
            }
        }
        if (isBomb(row, col)){
            setPanel(row, col, MISSBOMB);
            return false;
        }
        setPanel(row, col, getOpenPat(row, col));
        ++nOpen;
        if (randomPos != null && randomPos.x == col && randomPos.y == row){
            shuffleMines();
            recalc();
            repaint();
        }
        return true;
    }
    /**
     * ͂̃pl}[N
     * @param row YW
     * @param col XW
     */
    protected void markAround(int row, int col){
        for (int i = 0; i < aDx.length; ++i){
	    if (getPanel(row + aDy[i], col + aDx[i]) == CLOSE){
		setPanel(row + aDy[i], col + aDx[i], FLAG);
		nRest--;
	    }
        }
    }
    /**
     * ͂̃plJ
     * @param row YW
     * @param col XW
     */
    protected final boolean openAround(int row, int col){
        boolean rv = true;
        for (int i = 0; i < aDx.length; ++i){
	    if (randomPos != null &&
		randomPos.x == col + aDx[i] && 
		randomPos.y == row + aDy[i]) continue;
	    if (!recOpen(row + aDy[i], col + aDx[i])) rv = false;
         }
        return rv;
    }
    protected boolean recOpen(int row, int col){
        if (!CheckPush(row, col)) return true;
        if (!oneOpen(row, col)) return false;
        if (getPanel(row, col) == OPEN_0) return openAround(row, col);
        lcdRest.setValue(nRest);
        return true;
    }
    public final void setPanel(int row, int col, int panel){
        request[ row + 1 ][ col + 1 ] = panel;
    }
    public final int getPanel(int row, int col){
        return request[row + 1][col + 1];
    }
    /** nCXRA̖O */
    protected String inputName(){

	String[] msg = new String[2];
        switch(mode){
        case 0:
            msg[0] = BombBase.res.getString("EASY");
            break;
        case 1:
            msg[0] = BombBase.res.getString("INTERMEDIATE");
            break;
        default:
            msg[0] = BombBase.res.getString("DIFFICULT");
            break;
        }
	msg[0] += " Time:" + Long.toString(lcdTime.getTime());
        msg[1] = BombBase.res.getString("IYN");
	return JOptionPane.showInputDialog(
	    BombSys.pane, msg, BombBase.res.getString("SCORE"),
	    JOptionPane.PLAIN_MESSAGE);
    }
    //    Ƃ̏
    protected final void win(){
        status = STAT_WIN;
        lcdTime.stopTimer();
        for (int i = 0 ; i < maxRows ; ++i){
            for (int j = 0 ; j < maxCols ; ++j){
                if (isBomb(i, j) && getPanel(i, j) == CLOSE){
                    setPanel(i, j, FLAG);
                }
            }
        }
        nRest = 0;
        lcdRest.setValue(0);
	if(mode != -1 && 
	   BombBase.scoreset.inRanking((int)lcdTime.getTime(), mode, fGameType)){
            String newName = inputName();
	    BombBase.scoreset.addRank((int)lcdTime.getTime(), newName, mode, fGameType);
	    BombBase.scoreset.saveFile();
        }
    }
    //    Ƃ̏
    void lose(){
        status = STAT_LOSE;
        lcdTime.stopTimer();
        for (int i = 0 ; i < maxRows ; ++i){
            for (int j = 0 ; j < maxCols ; ++j){
                if (isBomb(i, j) == true && getPanel(i, j) == CLOSE){
                    setPanel(i, j, BOMB);
                }
                if (isBomb(i, j) == false && getPanel(i, j) == FLAG){
                    setPanel(i, j, WRONG);
                }
		if(getPanel(i, j) == CLOSE && randomPos != null &&
		   randomPos.x == j && randomPos.y == i){
		    setPanel(i, j, PAT_RANDOM);
		}
            }
        }
    }
    protected final int getOpenPat(int y, int x){
        int i,j;
        if (randomPos != null && randomPos.x == x && randomPos.y == y){
            return PAT_RANDOM;
        }
        int count = 0;
        for (i = 0; i < aDx.length; ++i){
	    if (isBomb(y + aDy[i],x + aDx[i])) ++count;
        }
        return OPEN_0 + count;
    }
    protected void markClick(int row, int col){
        int p = getPanel(row, col);
        if (p == FLAG){
            setPanel(row, col, CLOSE);
            nRest++;
        } else if (p == CLOSE){
            setPanel(row, col, FLAG);
            nRest--;
        } else if (isOpen(row, col)){
            int count = 0;
	    for (int i = 0; i < aDx.length; ++i){
		if (!isOpen(row + aDy[i],col + aDx[i])){
		    if (getPanel(row + aDy[i],col + aDx[i]) != PAT_CRATER &&
			getPanel(row + aDy[i],col + aDx[i]) != UNDEF) ++count;
                }
            }
            if (p - OPEN_0 == count) markAround(row, col);
        }
    }
    protected abstract Point panelPos(int x, int y);
//    邩ǂ̃`FbN
    boolean CheckPush(int row, int col){
        if (row < 0 || row >= maxRows || col < 0 || col >= maxCols) return false;
        int p = getPanel(row, col);
        switch (p) {
        case CLOSE:
        case QUESTION:
        case PUSH:
        case QPUSH:
            return true;
        default:
            break;
        }
        return false;
    }
//    ̃pl
    void pushOnePanel(int row, int col){
        if (getPanel(row, col) == CLOSE){
            setPanel(row, col, PUSH);
        } else if (getPanel(row, col) == QUESTION){
            setPanel(row, col, QPUSH);
        }
    }
    protected void pushPanel(int row, int col){
        int p = getPanel(row, col);
        if (p < 0 || p > 8){
            pushOnePanel(row, col);
            return;
        }
	for (int i = 0; i < aDx.length; ++i){
	    pushOnePanel(row + aDy[i],col + aDx[i]);
	}
    }
//    plɖ߂
    void popOnePanel(int row, int col){
        if (getPanel(row, col) == PUSH){
            setPanel(row, col, CLOSE);
        } else if (getPanel(row, col) == QPUSH){
            setPanel(row, col, QUESTION);
        }
    }
    protected void popPanel(int row, int col){
        for (int i = 0; i < aDx.length; ++i){
	    popOnePanel(row + aDy[i], col + aDx[i]);
        }
	popOnePanel(row, col);
    }
//    JNbN̏
    protected void openClick(int r, int c){
        popPanel(r, c);
        if (superClick(r, c)){
            return;
        }
        if (!CheckPush(r, c)){
            return;
        }
        if (!recOpen(r, c)){
            lose();
        }
        if (nOpen + maxMines == maxPanels){
            win();
        }
    }
    public void update(Graphics g){
        paint(g);
    }
    //    MouseEventListener
    public void mouseEntered(MouseEvent e) {
    }
    public void mouseExited(MouseEvent e) {
	if (oldPos != null){
	    popPanel(oldPos.y, oldPos.x);
	    oldPos = null;
	    repaint();
	}
    }
    public void mouseClicked(MouseEvent e) {
    }
    //    jdk1.0.xȂ mouseDown
    public void mousePressed(MouseEvent e) {
        if (pause) return;
        if (status == STAT_WIN || status == STAT_LOSE) return;
        Point pos = panelPos(e.getX(), e.getY());
	if(oldPos != null && pos != null &&
	   oldPos.x == pos.x && oldPos.y == pos.y){
	    popPanel(oldPos.y, oldPos.x);
	    oldPos = null;
	}
        if (pos == null) return;
        int r = pos.y;
        int c = pos.x;
        oldPos = pos;
        if (e.isMetaDown() != false || e.isControlDown() != false){
            fPush = CLICK_MARK;
            markClick(r, c);
            lcdRest.setValue(nRest);
        } else {
            fPush = CLICK_OPEN;
            pushPanel(r, c);
        }
        repaint();
    }
    /** }EX̃hbO */
    public void mouseDragged(MouseEvent e) {
        if (pause) return;
        if (fPush != CLICK_OPEN) return;
        Point pos = panelPos(e.getX(), e.getY());
        if (pos == null){
	    if (oldPos != null){
		popPanel(oldPos.y, oldPos.x);
		oldPos = null;
		repaint();
	    }
	    return;
	}
        int r = pos.y;
        int c = pos.x;
	if(oldPos != null){
	    if (oldPos.x == pos.x && oldPos.y == pos.y) return;
	    popPanel(oldPos.y, oldPos.x);
	}
        oldPos = pos;
        pushPanel(r, c);
        repaint();
        return;
    }
    //    jdk1.0.xȂ mouseUp
    public void mouseReleased(MouseEvent e) {
        if (pause) return;
        e.consume();
        if (fPush != CLICK_OPEN) return;
        fPush = 0;
        Point pos = panelPos(e.getX(), e.getY());
        if (pos == null){
	    if (oldPos != null){
		popPanel(oldPos.y, oldPos.x);
		oldPos = null;
		repaint();
	    }
	    return;
	}
        openClick(pos.y, pos.x);
        repaint();
    }
    public void mouseMoved(MouseEvent e) {
    }
    public void itemStateChanged(ItemEvent e){
        if (e.getSource() instanceof Checkbox){
            String s = (String)((Checkbox)e.getSource()).getName();
            if (s.equals("CRATERS")){
                fGameType[CRATERS] = ((Checkbox)e.getSource()).getState();
            } else if (s.equals("MOVING")){
                fGameType[MOVING] = ((Checkbox)e.getSource()).getState();
            } else if (s.equals("RANDOMIZER")){
                fGameType[RANDOMIZER] = ((Checkbox)e.getSource()).getState();
            }
            reset();
        } else if (e.getSource() instanceof Choice){
            int index = ((Choice)e.getSource()).getSelectedIndex();
            setMode(index);
        }
    }
    /** KvʃTCY */
    public Dimension getPreferredSize(){
        return new Dimension(maxCols * tileSize, maxRows * tileSize);
    }
}

