/**
 *
 * @(#)JBombCanvas.java 1.5 1998/06/21
 * JBombQ[
 *  JDK1.1.X + swing1.02
 * @version 1.5
 * @author Qini.Nakagawa
 */

package jp.gr.java_conf.narick.game.mine;
import jp.gr.java_conf.narick.game.mine.*;
import jp.gr.java_conf.narick.util.*;
import java.awt.*;
import java.awt.event.*;

public class JBombCanvas extends BombCanvas {
//    constructor
    public JBombCanvas(){
	aDx = new int[]{-1, 0, 1, 1, 1, 0, -1, -1};
	aDy = new int[]{1, 1, 1, 0, -1, -1, -1, 0};
    }
    public final void setMode(int n){
        mode = n;
        switch(n){
        case 0:
            setting(8, 8, 10);
            break;
        case 1:
            setting(16, 16, 40);
            break;
        case 2:
            setting(16, 30, 99);
            break;
        default:
            mode = -1;
            break;
        }
    }
    protected void setting(int height, int width, int bombs){
        maxCols = width;
        maxRows = height;
        maxMines = bombs;
        setSize( maxCols * tileSize , maxRows * tileSize );
        request = new int[ height + 2 ][ width + 2 ];
        current = new int[ height + 2 ][ width + 2 ];
        bomb = new boolean[ height + 2 ][ width + 2 ];
        for ( int i = 0 ; i < maxRows + 2 ; ++i ){
            for ( int j = 0 ; j < maxCols + 2 ; ++j ){
                current[i][j] = UNDEF;
            }
        }
        reset();
        image = createImage(tileSize * maxCols, tileSize * maxRows);
	fitting();
    }
    public void reset(){
        int i, j;
        int x, y;
	pause = false;
        //  all panels close
        for (i = 0; i < maxRows; ++i){
            for(j = 0; j < maxCols; ++j){
                setPanel(i, j, CLOSE);
            }
        }
        nOpen = 0;
        // N[^̐ݒu
        if (fGameType[CRATERS]){
            int mc = maxRows * maxCols / 12;
            maxPanels = maxRows * maxCols - mc;
            while ( mc != 0 ){
                x = (int)(Math.random() * maxCols);
                y = (int)(Math.random() * maxRows);
                if (getPanel(y, x) == PAT_CRATER) continue;
                setPanel(y, x, PAT_CRATER);
                --mc;
            }
        }else{
            maxPanels = maxRows * maxCols;
            randomPos = null;
        }
	// _ړ
        if (fGameType[RANDOMIZER]){
            for ( ;; ){
                x = (int)(Math.random() * maxCols);
                y = (int)(Math.random() * maxRows);
                if (getPanel(y, x) != PAT_CRATER) break;
            }
            randomPos = new Point(x, y);
            setPanel(y, x, PAT_CRATER);
            maxPanels--;
        }
        shuffleMines();
        if (randomPos != null){
            setPanel(randomPos.y, randomPos.x, CLOSE);
            maxPanels++;
        }
        nRest = maxMines;
        lcdRest.setValue(nRest);
        status = STAT_IDLE;
        lcdTime.stopTimer();
        lcdTime.resetTimer();
        repaint();
    }
    public void paint(Graphics g){
        if (pause){
            g.fillRect(0, 0, tileSize * maxCols, tileSize * maxRows);
            return;
        }
        if (image == null){
            image = createImage(tileSize * maxCols, tileSize * maxRows);
            if (image == null ) return;
        }
        Graphics graphics = image.getGraphics();
        for (int i = 0; i < maxRows; ++i){
            for (int j = 0 ; j < maxCols; ++j){
                int p = request[i + 1][j + 1];
                if (current[i + 1][j + 1] != p){
                    graphics.drawImage(panelImage[p], j * tileSize, i * tileSize, null);
                    current[i + 1][j + 1] = p;
                }
            }
        }
        g.drawImage(image, 0, 0, null);
    }
    //    e𓮂
    void moveMine(){
        int i, j;
        int[] moto = RandomArray.getRandomArray(maxMines);
        int[] saki = RandomArray.getRandomArray(maxPanels - maxMines - maxMines - (fGameType[RANDOMIZER]? 1: 0));
        int r = 2 + (int)(Math.random() * 4);
        if (r > saki.length) r = saki.length;
        for (i = 0; i < maxRows; ++i){
            for (j = 0; j < maxCols; ++j){
            }
        }
    }
    /** NbN̏ꏊ */
    protected Point panelPos(int x, int y){
        Point rv = new Point( x / tileSize , y / tileSize );
        if ( rv.y < 0 || rv.y >= maxRows || rv.x < 0 || rv.x >= maxCols ) return null;
        return rv;
    }
    /** TCYԂ */
    public Dimension getPreferredSize(){
        return new Dimension(maxCols * tileSize, maxRows * tileSize);
    }
}
