//----------------------------------------------------------------------
//
//    ScorePanel.java    :    XRA\
//
//        Qini.Nakagawa
//
//----------------------------------------------------------------------
package jp.gr.java_conf.narick.game.mine;
import jp.gr.java_conf.narick.game.mine.*;

import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class ScorePanel extends JComponent{

    ScoreSet ss; // XRA
    JCheckBox check[] = new JCheckBox[2];
    JComboBox cb;
    ScoreTableModel model;
    JTable table;
//    JLabel aNameLabel[];
//    JLabel aTimeLabel[];

    class Change implements ActionListener{
        protected ScorePanel sp;
        public Change(ScorePanel p){
            sp = p;
        }
        public void actionPerformed(ActionEvent e){
            sp.changeMode();
        }
    }
    class ScoreTableModel extends DefaultTableModel {
        ScoreTableModel(String[] colname){
            super(colname, 5);
            for(int i = 0; i < 5; ++i){
                setValueAt(Integer.toString(i + 1), i, 0);
            }
        }
        /** XRA̕\ */
        void addData(ScoreRecord[] score){
            for (int i = 0; i < 5; ++i){
                if(score[i] == null){
                    setValueAt("", i, 1);
                    setValueAt(null, i, 2);
                } else {
                    setValueAt(score[i].name, i, 1);
                    setValueAt("" + score[i].time, i, 2);
                }
            }
        }
    }
/*
    void addData(ScoreRecord[] srec){
	for(int i = 0; i < 5; ++i){
            if(srec[i] == null){
                aNameLabel[i].setText("");
                aTimeLabel[i].setText("");
            } else {
                aNameLabel[i].setText(srec[i].name);
                aTimeLabel[i].setText("" +  srec[i].time);
            }
        }
    }
*/
    /** \̕ύX */
    public void changeMode(){
        int i;
        boolean flag[] = new boolean[check.length];
        for (i = 0; i < check.length; ++i){
            flag[i] = check[i].isSelected();
        }
        int mode = cb.getSelectedIndex();
        if(mode == -1){
            mode = 0;
            cb.setSelectedIndex(0);
        }
//        addData(ss.getScoreRec(mode, flag));
        model.addData(ss.getScoreRec(mode, flag));
    }
    public Dimension getPreferredSize(){
        return new Dimension(340, 140);
    }
    public ScorePanel(ScoreSet owner){
        
        ss = owner;
        setLayout(new BorderLayout());

        JPanel p = new JPanel();
        cb = new JComboBox();
        cb.addItem(BombBase.res.getString("EASY"));
        cb.addItem(BombBase.res.getString("INTERMEDIATE"));
        cb.addItem(BombBase.res.getString("DIFFICULT"));
        cb.addActionListener(new Change(this));
        p.add(cb);

        check[0] = new JCheckBox(BombBase.res.getString("CRATERS"));
        check[1] = new JCheckBox(BombBase.res.getString("RANDOMIZER"));
        check[0].addActionListener(new Change(this));
        check[1].addActionListener(new Change(this));
        p.add(check[0]);
        p.add(check[1]);
        add(p, BorderLayout.NORTH);

        String[] colName = {
	    "LANK", "NAME", "TIME"
	};
        model = new ScoreTableModel(colName);
        table = new JTable(model);
	for(int i = 0; i < 3; ++i){
	    table.getColumn(colName[i]).setHeaderValue(BombBase.res.getString(colName[i]));
	}
        table.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
//        TableColumn tc = table.getColumn("LANK");
//        tc.setWidth(30);
//        JTableHeader header = table.getTableHeader();
//        header.setUpdateTableInRealTime(true);
        add(new JScrollPane(table), BorderLayout.CENTER);
/*
	p = new JPanel();
	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints c = new GridBagConstraints();
	c.fill = GridBagConstraints.BOTH;
        p.setLayout(gbl);

	aNameLabel = new JLabel[5];
	aTimeLabel = new JLabel[5];
	JLabel l;
	l = new JLabel("LANK");
	c.weightx = 0.2;
	c.gridwidth = GridBagConstraints.RELATIVE;
	gbl.setConstraints(l, c);
	p.add(l);
	l = new JLabel("NAME");
	c.weightx = 1.0;
	c.gridwidth = GridBagConstraints.RELATIVE;
	gbl.setConstraints(l, c);
	p.add(l);
	l = new JLabel("TIME");
	c.weightx = 1.0;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gbl.setConstraints(l, c);
	p.add(l);
	for(int i = 0; i < 5; ++i){
	    l = new JLabel(Integer.toString(i + 1));
	    c.weightx = 0.2;
	    c.gridwidth = GridBagConstraints.RELATIVE;
	    gbl.setConstraints(l, c);
	    p.add(l);
	    aNameLabel[i] = new JLabel();
	    c.weightx = 1.0;
	    c.gridwidth = GridBagConstraints.RELATIVE;
	    gbl.setConstraints(aNameLabel[i], c);
	    p.add(aNameLabel[i]);
	    aTimeLabel[i] = new JLabel();
	    c.weightx = 1.0;
	    c.gridwidth = GridBagConstraints.REMAINDER;
	    gbl.setConstraints(aTimeLabel[i], c);
	    p.add(aTimeLabel[i]);
	}
	add(p,BorderLayout.CENTER);
*/
        changeMode();
    }
/*
    public static void main(String[] args){
        BombBase.res = ResourceBundle.getBundle("jp.gr.java_conf.narick.game.mine.BombRes");
        JFrame f = new JFrame();
        
        f.setSize(400,300);
        ScoreSet ss = new ScoreSet();
        ss.loadFile();
        ScorePanel sp = new ScorePanel(ss);
//      ScoreTableModel model = new ScoreTableModel(sp.columnNames);
//      JTable table = new JTable(model);
        JScrollPane pane = new JScrollPane(sp.table);
        f.getContentPane().add(pane);
        f.setVisible(true);
    }
*/
}
