//----------------------------------------------------------------------
//
//    ScoreSet.java    :    XRA\
//
//        Qini.Nakagawa
//
//----------------------------------------------------------------------
package jp.gr.java_conf.narick.game.mine;
import jp.gr.java_conf.narick.game.mine.*;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;


public class ScoreSet {
    static final String SCORE_FILE = "minesco.ser";
    protected ScoreRecord[][] aScore;

    ScoreSet(){
	reset();
    }

    /** XRÃZbg */
    public void reset(){
	aScore = new ScoreRecord[12][5];
    }
    public boolean inRanking(int time, int mode, boolean[] flags){
	int i;
	int j = 1;
	for(i = 0; i < flags.length; ++i){
	    if(flags[i]) mode += (j * 3);
	    j *= 2;
	}
	return aScore[mode][4] == null || aScore[mode][4].time > time;
    }
    public boolean addRank(int time, String name, int mode, boolean flags[]){
	int i;
	int j = 1;
	for(i = 0; i < flags.length; ++i){
	    if(flags[i]) mode += (j * 3);
	    j *= 2;
	}
	for(j = 0;j < 5; ++j){
	    if (aScore[mode][j] == null ||
		aScore[mode][j].time > time) break; 
	}
	if(j == 5) return false;
	for(i = 4; i > j; --i){
	    aScore[mode][i] = aScore[mode][i - 1];
	}
	aScore[mode][i] = new ScoreRecord(time, name);
	return true;
    }
    public void showDialog(){
	ScorePanel p = new ScorePanel(this);
	JOptionPane.showMessageDialog(BombSys.pane, p, "SCORE",
				      JOptionPane.PLAIN_MESSAGE);
    }
    public ScoreRecord[] getScoreRec(int mode, boolean[] flags){
	int i;
	int j = 1;
	for(i = 0; i < flags.length; ++i){
	    if(flags[i]) mode += (j * 3);
	    j *= 2;
	}
	return aScore[mode];
    }
/*
    public void streamOut(OutputStream out) throws IOException{
        int i;
	ObjectOutputStream oos = new ObjectOutputStream(out);
	oos.writeObject(aScore);
    }

    public boolean streamIn(InputStream stream) throws IOException{

        try{

            int ch;
            int n = 0;
            StringBuffer sb = new StringBuffer();
            for(;;){
                ch = stream.read();
                if(ch == -1) break;
                if( ch == '\n'){
                    if (n % 2 == 0){
                        aTime[n/2] = Long.parseLong(sb.toString());
                    }else{
                        aName[n/2] = sb.toString();
                    }
                    sb = new StringBuffer();
                    ++n;
                    if (n ==6)break;
                }else{
                    sb.append((char)ch);
                }
            }
            stream.close();
            return true;
        }
        catch(NumberFormatException e){
            reset();
            return false;
        }

	return false;
    }
*/
    public void loadFile(String filename){
	
        try {
            ObjectInputStream ois = new ObjectInputStream(
		new FileInputStream(filename));
            aScore = (ScoreRecord[][])ois.readObject();
	    ois.close();
        }
        catch(IOException ex ){
            System.err.println(ex.toString());
            return;
        }
        catch(ClassNotFoundException ex){
            System.err.println(ex.toString());
            return;
        }
    }
    public void loadFile(){
	loadFile(SCORE_FILE);
    }
    public void saveFile(String filename){
        try {
            ObjectOutputStream oos = new ObjectOutputStream(
		new FileOutputStream(filename));
            oos.writeObject(aScore);
            oos.close();
        }
        catch( IOException ex ){
            System.err.println(ex.toString());
            return;
        }
    }
    public void saveFile(){
	saveFile(SCORE_FILE);
    }
/*
    public void loadDialog(){
	JFileChooser fd = new JFileChooser(parent, "Load");
	fd.show();
	loadFile(fd.getFile());
	streamIn(fr);
    }
    public void saveDialog(){
	JFileChooser fd = new JFileChooser(parent, "Save", JFileChooser.SAVE);
	fd.show();
	saveFile(fd.getFile());
    }
*/
}

