/**
 *    JLcd.java
 *    LCD\(swing1.1)
 */
package jp.gr.java_conf.narick.util;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import javax.swing.*;

class LcdIcon implements Icon {
    static final short lcdMark[] ={
	0x5f, 0x05, 0x76, 0x75, 0x2d, 0x79,
	0x7b, 0x45, 0x7f, 0x7d, 0x20, 0x00
    };
    static final int x_6[] = {
	2, 14, 12, 4
    };
    static final int y_6[] = {
	1, 1, 3, 3
    };
    static final int x_4[] = {
	3, 13, 15, 1
    };
    static final int y_4[] = {
	29, 29, 31, 31
    };
    static final int x_5[] = {
	3, 13, 13, 3
    };
    static final int y_5[] = {
	15, 15, 17, 17
    };
    static final int x_0[] = {
	15, 15, 13, 13
    };
    static final int x_1[] = {
	1, 1, 3, 3
    };
    static final int y_2[] = {
	2, 15, 13, 4
    };
    static final int y_0[] = {
	29, 16, 18, 27
    };

    static final int width = 16;
    static final int height = 32;
    private int number;
    private Color offColor;
    private Color shineColor;
    private Color backColor;
    
    private void createLcd(Graphics g, int n){
	int aX[];
	int aY[];
	int i;
	
	switch (n){
	case 6:
	    aX = x_6;
	    aY = y_6;
	    break;
	case 5:
	    aX = x_5;
	    aY = y_5;
	    break;
	case 4:
	    aX = x_4;
	    aY = y_4;
	    break;
	case 3:
	    aX = x_1;
	    aY = y_2;
	    break;
	case 2:
	    aX = x_0;
	    aY = y_2;
	    break;
	case 1:
	    aX = x_1;
	    aY = y_0;
	    break;
//	    case 0:
	default:
	    aX = x_0;
	    aY = y_0;
	    break;
	}
	g.fillPolygon(aX, aY, aX.length);
    }
    public LcdIcon(int i, Color o, Color s, Color b){
	number = i;
	offColor = o;
	shineColor = s;
	backColor = b;
    }
    public void paintIcon(Component c, Graphics g, int x, int y){
	// C[W\̏ꍇ
	// OtBbNXR}h̏ꍇ
	g.setColor(backColor);
	g.fillRect(0, 0, 16, 32);
	short mask = 1;
	short m2 = lcdMark[number];
	for (int i = 0 ; i < 7 ; ++i){
	    if ((m2 & mask) != 0){
		g.setColor(shineColor);
	    } else {
		g.setColor(offColor);
	    }
	    createLcd(g, i);
	    mask <<= 1;
	}
    }
    
    public int getIconWidth(){
	return this.width;
    }
    /**  */
    public int getIconHeight(){
	return this.height;
    }    
}

public class JLcd extends JComponent implements Serializable {
    private transient LcdIcon aImage[] = new LcdIcon[12];
    private transient JLabel[] aLabel;
    private Color offColor;
    private Color shineColor;
    private Color backColor;
    private int figure = 3;             // 
    private int max = 999;              // ő吔
    private int value;  // \
    static final int MINUS = 10;
    static final int BRANK = 11;
    private void createLcdIcon(){
        for(int i = 0; i < aImage.length; ++i){
            aImage[i] = new LcdIcon(i, offColor, shineColor, backColor);
        }
    }
    /** l̎擾 */
    public int getValue(){
        return value;
    }
    /** l̐ݒ */
    public void setValue(int n){
        value = n;
        update();
    }
    /** 邢Ƃ̐F̎w */
    public void setShineColor(Color c){
        setBackground(Color.black);
        shineColor = c;
        createLcdIcon();
        update();
    }
    public Color getShineColor(){
        return shineColor;
    }
    public void setOffColor(Color c){
        offColor = c;
        createLcdIcon();
        update();
    }
    public Color getOffColor(){
        return offColor;
    }
    public void setBackColor(Color c){
        backColor = c;
        createLcdIcon();
        update();
    }
    public Color getBackColor(){
        return backColor;
    }
    
    /** ̐ݒ */
    public void setFigure(int n){
	int i;
        figure = n;
        setSize(figure * 16, 32);
        setMinimumSize(new Dimension(figure * 16, 32));
	setLayout(new GridLayout(1, n));
	aLabel = new JLabel[n];
	removeAll();
	for(i = 0; i < n; ++i){
	    aLabel[i] = new JLabel(aImage[0]);
	    add(aLabel[i]);
	}
	
    }
    public Dimension getPreferredSize(){
        return new Dimension(figure * 16, 32);
    }
    /** ̎擾 */
    public int getFigure(){
        return figure;
    }
    /**  */
    public void init(){
        value = 0;
        shineColor = Color.red;
        offColor = new Color(64, 0, 0);
        backColor = Color.black;
	createLcdIcon();
        setFigure(3);
    }
    /** ftHgRXgN^ */
    public JLcd(){
        init();
    }
    public void update(){
        int i;
        boolean minus = false;
        boolean brank = false;
        long n = value;
        int max = 1;

        for (i = 1 ; i < figure ; ++i){
            max *= 10;
        }
        if (value < 0){
            minus = true;
            n = -n;
        } else {
            max *= 10;
        }
        if (n >= max){
            for (i = 0 ; i < figure ; ++i){
                putColumn(i, MINUS);
            }
            return;
        }
        for (i = figure - 1 ; i >= 0 ; --i){
            if (i == 0 && minus){
                putColumn(0, MINUS);
                continue;
            }
            if (brank){
                putColumn(i, BRANK);
                continue;
            }
            int pat = (int)(n % 10);
            putColumn(i, pat);
            n /= 10;
            if (n == 0) brank = true;
        }
    }
    private void putColumn(int col, int pat){
	aLabel[col].setIcon(aImage[pat]);
    }
}
